;*******************************************************************************
;
;  WINSTUB.ASM	- assembly source to an alternative WINSTUB.EXE for
;		  small Microsoft Windows programs.
;
;     The only "enhancement" that this WINSTUB offers over the stock
;     Microsoft variety is that it will cause the description from
;     your module definition file to be displayed along with the
;     "This program requires Microsoft Windows" message when the
;     program is run from DOS.	    Nothing very fancy, but it does offer
;     a slightly less cold reception to the DOS world (and to novice
;     users.)
;
;     I have not tested this code very thoroughly.  It seems to work
;     just fine with the small ( < 30k ) applications I've been working
;     with, in both the small and medium models.  Please let me know if
;     you manage to get it to break.
;
;
;			  Gordon Harris
;			  3349 Humboldt Ave S.
;			  Minneapolis, MN 55408
;
;	      Comments to my CompuServe address [72611,620]
;
;     P.S.  I don't have a clue if this code will work with Windows 3.0 apps.
;
;******************************************************************************* 

	 TITLE	  WinStub
	 DOSSEG
	 .MODEL   SMALL,C

	 .DATA

	 .CODE
Winstub  proc
	 push  es
	 pop   ds		       ; Segment of new-style header info block
	 ;mov	bx,032ah
	 mov   bx,032ch 	       ; Contains offset of the nonresident-
	 mov   ax,word ptr ds:[bx]     ; name table, relative to beg. of file
	 sub   ax,100h		       ; Subtract old exe header
	 mov   bx,ax
	 mov   cx,ds:[bx]	       ; Length of string.
	 xor   ch,ch
	 mov   dx,bx
	 inc   dx		       ; points to description text
	 mov   bx,2		       ; output to stderr
	 mov   ah,40h
	 int   21h

	 push  cs
	 pop   ds
	 mov   dx, offset szMsg
	 mov   cx, szMsgLen
	 mov   ah,40h
	 int   21h

stuberr:
	 mov   ax,4c01h
	 int   21h
Winstub  endp

szMsg	 db    0dh, 0ah, 'This program requires Microsoft Windows.',  0dh, 0ah
szMsgLen equ $-szMsg
	 end
